/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /local/robotpkg/var/tmp/robotpkg/simulation/mrsim-genom3/work/templates/ros/client/ros/mrsim_ros/srv/get_external_disturbance.srv
 *
 */


#ifndef MRSIM_ROS_MESSAGE_GET_EXTERNAL_DISTURBANCERESPONSE_H
#define MRSIM_ROS_MESSAGE_GET_EXTERNAL_DISTURBANCERESPONSE_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>

#include <mrsim_ros/mrsim_ids_disturb_s.h>

namespace mrsim_ros
{
template <class ContainerAllocator>
struct get_external_disturbanceResponse_
{
  typedef get_external_disturbanceResponse_<ContainerAllocator> Type;

  get_external_disturbanceResponse_()
    : genom_success(false)
    , genom_exdetail()
    , disturb()  {
    }
  get_external_disturbanceResponse_(const ContainerAllocator& _alloc)
    : genom_success(false)
    , genom_exdetail(_alloc)
    , disturb(_alloc)  {
    }



   typedef uint8_t _genom_success_type;
  _genom_success_type genom_success;

   typedef std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other >  _genom_exdetail_type;
  _genom_exdetail_type genom_exdetail;

   typedef  ::mrsim_ros::mrsim_ids_disturb_s_<ContainerAllocator>  _disturb_type;
  _disturb_type disturb;




  typedef boost::shared_ptr< ::mrsim_ros::get_external_disturbanceResponse_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::mrsim_ros::get_external_disturbanceResponse_<ContainerAllocator> const> ConstPtr;

}; // struct get_external_disturbanceResponse_

typedef ::mrsim_ros::get_external_disturbanceResponse_<std::allocator<void> > get_external_disturbanceResponse;

typedef boost::shared_ptr< ::mrsim_ros::get_external_disturbanceResponse > get_external_disturbanceResponsePtr;
typedef boost::shared_ptr< ::mrsim_ros::get_external_disturbanceResponse const> get_external_disturbanceResponseConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::mrsim_ros::get_external_disturbanceResponse_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::mrsim_ros::get_external_disturbanceResponse_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace mrsim_ros

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': False, 'IsMessage': True, 'HasHeader': False}
// {'mrsim_ros': ['mrsim_ros/msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::mrsim_ros::get_external_disturbanceResponse_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::mrsim_ros::get_external_disturbanceResponse_<ContainerAllocator> const>
  : FalseType
  { };

template <class ContainerAllocator>
struct IsMessage< ::mrsim_ros::get_external_disturbanceResponse_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::mrsim_ros::get_external_disturbanceResponse_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::mrsim_ros::get_external_disturbanceResponse_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::mrsim_ros::get_external_disturbanceResponse_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::mrsim_ros::get_external_disturbanceResponse_<ContainerAllocator> >
{
  static const char* value()
  {
    return "ed31f1bd8e17f3c66378ec48ed97ebcb";
  }

  static const char* value(const ::mrsim_ros::get_external_disturbanceResponse_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0xed31f1bd8e17f3c6ULL;
  static const uint64_t static_value2 = 0x6378ec48ed97ebcbULL;
};

template<class ContainerAllocator>
struct DataType< ::mrsim_ros::get_external_disturbanceResponse_<ContainerAllocator> >
{
  static const char* value()
  {
    return "mrsim_ros/get_external_disturbanceResponse";
  }

  static const char* value(const ::mrsim_ros::get_external_disturbanceResponse_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::mrsim_ros::get_external_disturbanceResponse_<ContainerAllocator> >
{
  static const char* value()
  {
    return "bool genom_success\n\
string genom_exdetail\n\
mrsim_ids_disturb_s disturb\n\
\n\
\n\
================================================================================\n\
MSG: mrsim_ros/mrsim_ids_disturb_s\n\
# IDL struct ::mrsim::ids::disturb_s\n\
or_rb3d_force force\n\
or_rb3d_torque torque\n\
float64 zmin\n\
float64 zmax\n\
float64 noise\n\
float64 period\n\
\n\
================================================================================\n\
MSG: mrsim_ros/or_rb3d_force\n\
# IDL struct ::or::rb3d::force\n\
float64 x\n\
float64 y\n\
float64 z\n\
\n\
================================================================================\n\
MSG: mrsim_ros/or_rb3d_torque\n\
# IDL struct ::or::rb3d::torque\n\
float64 x\n\
float64 y\n\
float64 z\n\
";
  }

  static const char* value(const ::mrsim_ros::get_external_disturbanceResponse_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::mrsim_ros::get_external_disturbanceResponse_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.genom_success);
      stream.next(m.genom_exdetail);
      stream.next(m.disturb);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct get_external_disturbanceResponse_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::mrsim_ros::get_external_disturbanceResponse_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::mrsim_ros::get_external_disturbanceResponse_<ContainerAllocator>& v)
  {
    s << indent << "genom_success: ";
    Printer<uint8_t>::stream(s, indent + "  ", v.genom_success);
    s << indent << "genom_exdetail: ";
    Printer<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other > >::stream(s, indent + "  ", v.genom_exdetail);
    s << indent << "disturb: ";
    s << std::endl;
    Printer< ::mrsim_ros::mrsim_ids_disturb_s_<ContainerAllocator> >::stream(s, indent + "  ", v.disturb);
  }
};

} // namespace message_operations
} // namespace ros

#endif // MRSIM_ROS_MESSAGE_GET_EXTERNAL_DISTURBANCERESPONSE_H
