/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /local/robotpkg/var/tmp/robotpkg/simulation/mrsim-genom3/work/templates/ros/client/ros/mrsim_ros/msg/mrsim_ids_disturb_s.msg
 *
 */


#ifndef MRSIM_ROS_MESSAGE_MRSIM_IDS_DISTURB_S_H
#define MRSIM_ROS_MESSAGE_MRSIM_IDS_DISTURB_S_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>

#include <mrsim_ros/or_rb3d_force.h>
#include <mrsim_ros/or_rb3d_torque.h>

namespace mrsim_ros
{
template <class ContainerAllocator>
struct mrsim_ids_disturb_s_
{
  typedef mrsim_ids_disturb_s_<ContainerAllocator> Type;

  mrsim_ids_disturb_s_()
    : force()
    , torque()
    , zmin(0.0)
    , zmax(0.0)
    , noise(0.0)
    , period(0.0)  {
    }
  mrsim_ids_disturb_s_(const ContainerAllocator& _alloc)
    : force(_alloc)
    , torque(_alloc)
    , zmin(0.0)
    , zmax(0.0)
    , noise(0.0)
    , period(0.0)  {
    }



   typedef  ::mrsim_ros::or_rb3d_force_<ContainerAllocator>  _force_type;
  _force_type force;

   typedef  ::mrsim_ros::or_rb3d_torque_<ContainerAllocator>  _torque_type;
  _torque_type torque;

   typedef double _zmin_type;
  _zmin_type zmin;

   typedef double _zmax_type;
  _zmax_type zmax;

   typedef double _noise_type;
  _noise_type noise;

   typedef double _period_type;
  _period_type period;




  typedef boost::shared_ptr< ::mrsim_ros::mrsim_ids_disturb_s_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::mrsim_ros::mrsim_ids_disturb_s_<ContainerAllocator> const> ConstPtr;

}; // struct mrsim_ids_disturb_s_

typedef ::mrsim_ros::mrsim_ids_disturb_s_<std::allocator<void> > mrsim_ids_disturb_s;

typedef boost::shared_ptr< ::mrsim_ros::mrsim_ids_disturb_s > mrsim_ids_disturb_sPtr;
typedef boost::shared_ptr< ::mrsim_ros::mrsim_ids_disturb_s const> mrsim_ids_disturb_sConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::mrsim_ros::mrsim_ids_disturb_s_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::mrsim_ros::mrsim_ids_disturb_s_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace mrsim_ros

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': True, 'IsMessage': True, 'HasHeader': False}
// {'actionlib_msgs': ['/opt/openrobots/share/actionlib_msgs/msg'], 'std_msgs': ['/opt/openrobots/share/std_msgs/msg'], 'mrsim_ros': ['mrsim_ros/msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::mrsim_ros::mrsim_ids_disturb_s_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::mrsim_ros::mrsim_ids_disturb_s_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::mrsim_ros::mrsim_ids_disturb_s_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::mrsim_ros::mrsim_ids_disturb_s_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::mrsim_ros::mrsim_ids_disturb_s_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::mrsim_ros::mrsim_ids_disturb_s_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::mrsim_ros::mrsim_ids_disturb_s_<ContainerAllocator> >
{
  static const char* value()
  {
    return "1c0f2916d84774bd8d498ccb9e35ea56";
  }

  static const char* value(const ::mrsim_ros::mrsim_ids_disturb_s_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0x1c0f2916d84774bdULL;
  static const uint64_t static_value2 = 0x8d498ccb9e35ea56ULL;
};

template<class ContainerAllocator>
struct DataType< ::mrsim_ros::mrsim_ids_disturb_s_<ContainerAllocator> >
{
  static const char* value()
  {
    return "mrsim_ros/mrsim_ids_disturb_s";
  }

  static const char* value(const ::mrsim_ros::mrsim_ids_disturb_s_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::mrsim_ros::mrsim_ids_disturb_s_<ContainerAllocator> >
{
  static const char* value()
  {
    return "# IDL struct ::mrsim::ids::disturb_s\n\
or_rb3d_force force\n\
or_rb3d_torque torque\n\
float64 zmin\n\
float64 zmax\n\
float64 noise\n\
float64 period\n\
\n\
================================================================================\n\
MSG: mrsim_ros/or_rb3d_force\n\
# IDL struct ::or::rb3d::force\n\
float64 x\n\
float64 y\n\
float64 z\n\
\n\
================================================================================\n\
MSG: mrsim_ros/or_rb3d_torque\n\
# IDL struct ::or::rb3d::torque\n\
float64 x\n\
float64 y\n\
float64 z\n\
";
  }

  static const char* value(const ::mrsim_ros::mrsim_ids_disturb_s_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::mrsim_ros::mrsim_ids_disturb_s_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.force);
      stream.next(m.torque);
      stream.next(m.zmin);
      stream.next(m.zmax);
      stream.next(m.noise);
      stream.next(m.period);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct mrsim_ids_disturb_s_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::mrsim_ros::mrsim_ids_disturb_s_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::mrsim_ros::mrsim_ids_disturb_s_<ContainerAllocator>& v)
  {
    s << indent << "force: ";
    s << std::endl;
    Printer< ::mrsim_ros::or_rb3d_force_<ContainerAllocator> >::stream(s, indent + "  ", v.force);
    s << indent << "torque: ";
    s << std::endl;
    Printer< ::mrsim_ros::or_rb3d_torque_<ContainerAllocator> >::stream(s, indent + "  ", v.torque);
    s << indent << "zmin: ";
    Printer<double>::stream(s, indent + "  ", v.zmin);
    s << indent << "zmax: ";
    Printer<double>::stream(s, indent + "  ", v.zmax);
    s << indent << "noise: ";
    Printer<double>::stream(s, indent + "  ", v.noise);
    s << indent << "period: ";
    Printer<double>::stream(s, indent + "  ", v.period);
  }
};

} // namespace message_operations
} // namespace ros

#endif // MRSIM_ROS_MESSAGE_MRSIM_IDS_DISTURB_S_H
